class RefactorAuthenticationAndAuthorization < ActiveRecord::Migration
  def self.up
    create_table :authorized_users do |t|
      t.string :username
      t.string :status
      t.string :origin, :default => 'local'

      t.timestamps
    end
    execute <<-SQL
    INSERT INTO `authorized_users` (`id`, `username`, `status`, `created_at`, `updated_at`)
    SELECT `id`, `username`, `status`, `created_at`, `updated_at` FROM `users`;
    SQL

    remove_column :users, :status

    rename_table :roles_users, :authorized_users_roles
    rename_column :authorized_users_roles, :user_id, :authorized_user_id
  end

  def self.down
    rename_column :authorized_users_roles, :authorized_user_id, :user_id
    rename_table :authorized_users_roles, :roles_users

    add_column :users, :status, :string
    execute "ALTER TABLE `users` MODIFY `status` VARCHAR(255) AFTER `encryption_salt`;"
    execute <<-SQL
      ALTER TABLE `users` MODIFY `status` VARCHAR(255) AFTER `encryption_salt`;
      UPDATE `users` as `a`
        INNER JOIN `authorized_users` as `b`
        ON `a`.`username` = `b`.`username`
      SET `a`.`id`     = `b`.`id`,
          `a`.`status` = `b`.`status`
      ;
    SQL
    drop_table :authorized_users
  end
end
